#ifndef __ac_FIRST__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1__
#define __ac_FIRST__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1__
#define __ac_FIRST_FILE__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_inc_Puma_BCList_h__

#ifndef __ac_h_
#define __ac_h_
#ifdef __cplusplus
namespace AC {
  typedef const char* Type;
  enum JPType { CALL = 0x0004, EXECUTION = 0x0008, CONSTRUCTION = 0x0010, DESTRUCTION = 0x0020 };
  struct Action {
    void **_args; void *_result; void *_target; void *_that; void *_fptr;
    void (*_wrapper)(Action &);
    inline void trigger () { _wrapper (*this); }
  };
  struct AnyResultBuffer {};
  template <typename T> struct ResultBuffer : public AnyResultBuffer {
    char _data[sizeof (T)];
    ~ResultBuffer () { ((T*)_data)->T::~T(); }
    operator T& () const { return *(T*)_data; }
  };
  template <typename T, typename N> struct TL {
    typedef T type; typedef N next; enum { ARGS = next::ARGS + 1 };
  };
  struct TLE { enum { ARGS = 0 }; };
  template <typename T> struct Referred { typedef T type; };
  template <typename T> struct Referred<T &> { typedef T type; };
  template <typename TL, int I> struct Arg {
    typedef typename Arg<typename TL::next, I - 1>::Type Type;
    typedef typename Referred<Type>::type ReferredType;
  };
  template <typename TL> struct Arg<TL, 0> {
    typedef typename TL::type Type;
    typedef typename Referred<Type>::type ReferredType;
  };
  template <typename T> int ttest(...);
  template <typename T> char ttest(typename T::__AttrTypes const volatile *);
  template<typename T> struct HasTypeInfo {
    enum { RET=((sizeof(ttest<T>(0))==1)?1:0) };
  };
  template<typename T, int HAVE = HasTypeInfo<T>::RET> struct TypeInfo {
    enum { AVAILABLE = 0 };
  };
  template<typename T> struct TypeInfo<T, 1> {
    enum { AVAILABLE = 1 };
    enum { ELEMENTS = T::__AttrTypes::ARGS };
    template<int I>
    struct Member : public AC::Arg<typename T::__AttrTypes,I> {};
    template<int I>
    static typename Member<I>::ReferredType* member (T* obj) {
      return (typename Member<I>::ReferredType*)obj->__attr (I);
    }
    static const char *member_name (T &obj, int i) {
      return obj.__attr_name (i);
    }
	 };
  template <class Aspect, int Index>
  struct CFlow {
    static int &instance () {
      static int counter = 0;
      return counter;
    }
    CFlow () { instance ()++; }
    ~CFlow () { instance ()--; }
    static bool active () { return instance () > 0; }
  };
}
inline void * operator new (__SIZE_TYPE__, AC::AnyResultBuffer *p) { return p; }
inline void operator delete (void *, AC::AnyResultBuffer *) { } // for VC++
#endif // __cplusplus
#endif // __ac_h_
#endif // __ac_FIRST__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1__

#line 1 "/tmp/tmp.jwSEixqBhI/aspectc++.svn20090918/Puma/gen-release/step1/inc/Puma/BCList.h"
// This file is part of PUMA.
// Copyright (C) 1999-2003  The PUMA developer team.
//                                                                
// This program is free software;  you can redistribute it and/or 
// modify it under the terms of the GNU General Public License as 
// published by the Free Software Foundation; either version 2 of 
// the License, or (at your option) any later version.            
//                                                                
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of 
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the  
// GNU General Public License for more details.                   
//                                                                
// You should have received a copy of the GNU General Public      
// License along with this program; if not, write to the Free     
// Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
// MA  02111-1307  USA                                            

#ifndef __bclist_h__
#define __bclist_h__

namespace Puma {

template <class Item, int BUCKET_SIZE = 32>
class BCList {

protected:
  struct Bucket {
    Bucket *_prev;
    Bucket *_next;
    Item *_write_pos;
    Item *_end_pos;
    Item _data[BUCKET_SIZE]; // large amount of token pointers to avoid new

    Bucket () : _prev (0), _next (0), _write_pos (_data),
      _end_pos (_data + BUCKET_SIZE) {}
    ~Bucket () { if (_next) delete _next; }
    void clear () {
      if (_next) delete _next;
      _next = 0;
      _write_pos = _data;
    }
    Item *first () { return _data; }
    Item *pos () const { return _write_pos; }
    Item *end () const { return _end_pos; }
    bool full () const { return _write_pos == _end_pos; }
    Bucket *new_bucket () {
      _next = new Bucket;
      _next->_prev = this;
      return _next;
    }
    void add (Item token) {
      *_write_pos = token;
      _write_pos++;
    }
  };

  Bucket _first_bucket; // the first bucket is part of the container
  Bucket *_last_bucket; // pointer to the last bucket for insertion

public:  
  class Iterator {
    friend class BCList<Item, BUCKET_SIZE>;

    Item *_item;
    Bucket *_bucket;

    Iterator (Item *item, Bucket *bucket) :
      _item (item), _bucket (bucket) {}

  public:
    Iterator () : _item (0) {}
    // this one is needed, because somewhere in Puma 0 is passed for an
    // Iterator argument
    Iterator (int i) { _item = 0; }
    operator bool () const { return _item != 0; }

    // comparison function    
    bool operator == (const Iterator& other) const {
      return _item == other._item;
    }
    bool operator != (const Iterator &other) const {
      return !(*this == other);
    }

    // ++ operators to iterate
    Iterator &operator ++ () {
      _item++;
      if (_item == _bucket->pos ()) {
        _bucket = _bucket->_next;
        _item = _bucket ? _bucket->first () : 0;
      }
      return *this;
    }
    Iterator operator ++ (int) {
      Iterator temp (*this);
      ++(*this);
      return temp;
    }
    Iterator &operator -- () {
      if (_item == _bucket->first ()) {
        _bucket = _bucket->_prev;
        if (_bucket) {
          _item = _bucket->pos ();
          _item--;
        }
        else {
          _item = 0;
        }
      }
      else {
        _item--; 
      }
      return *this;
    }
    Iterator operator -- (int) {
      Iterator temp (*this);
      --(*this);
      return temp;
    }
    
    // access functions
    Item &operator * () const { return *_item; }
    Item *operator -> () const { return _item; }
  };

  // constructor
  BCList () : _last_bucket (&_first_bucket) {}
  
  // start and end of the list
  Iterator begin () {
    return Iterator (_first_bucket.first (), &_first_bucket);
  }
  Iterator end () const {
    return Iterator ();
  }
  
  // add an element to the list
  Iterator add (Item item) {
    // if the last bucket is full extend the bucket chain
    if (_last_bucket->full ())
      _last_bucket = _last_bucket->new_bucket ();
    // the result is the position of the inserted item
    Item *result = _last_bucket->pos ();
    // add the item; the bucket is not full!
    _last_bucket->add (item);
    // return an iterator for the new item
    return Iterator (result, _last_bucket);
  }
  
  void reset () {
    _first_bucket.clear ();
    _last_bucket = &_first_bucket;
  }
};

} // namespace Puma

#endif /* __bclist_h__ */

#line 236 "/tmp/tmp.jwSEixqBhI/aspectc++.svn20090918/Puma/gen-release/step2/inc/Puma/BCList.h"

#ifdef __ac_FIRST_FILE__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_inc_Puma_BCList_h__
#ifdef __ac_need__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_CCExprResolveCC_ah__
#ifndef __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_CCExprResolveCC_ah__
#define __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_CCExprResolveCC_ah__
#include "CCExprResolveCC.ah"
#endif
#ifndef __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_ExtACTree_ah__
#define __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_ExtACTree_ah__
#include "ExtACTree.ah"
#endif
#ifndef __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_ExtGnu_ah__
#define __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_ExtGnu_ah__
#include "ExtGnu.ah"
#endif
#ifndef __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_PragmaOnceUnitState_ah__
#define __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_PragmaOnceUnitState_ah__
#include "PragmaOnceUnitState.ah"
#endif
#endif
#ifdef __ac_need__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_CCExprResolveH_ah__
#ifndef __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_CCExprResolveH_ah__
#define __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_CCExprResolveH_ah__
#include "CCExprResolveH.ah"
#endif
#endif
#ifdef __ac_need__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_CExprResolveCC_ah__
#ifndef __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_CExprResolveCC_ah__
#define __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_CExprResolveCC_ah__
#include "CExprResolveCC.ah"
#endif
#ifndef __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_ExtACTree_ah__
#define __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_ExtACTree_ah__
#include "ExtACTree.ah"
#endif
#ifndef __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_ExtGnu_ah__
#define __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_ExtGnu_ah__
#include "ExtGnu.ah"
#endif
#ifndef __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_PragmaOnceUnitState_ah__
#define __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_PragmaOnceUnitState_ah__
#include "PragmaOnceUnitState.ah"
#endif
#endif
#ifdef __ac_need__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_CExprResolveH_ah__
#ifndef __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_CExprResolveH_ah__
#define __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_CExprResolveH_ah__
#include "CExprResolveH.ah"
#endif
#endif
#ifdef __ac_need__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_WinIfExists_ah__
#ifndef __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_WinIfExists_ah__
#define __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_WinIfExists_ah__
#include "WinIfExists.ah"
#endif
#endif
#ifdef __ac_need__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_WinImportHandler_ah__
#ifndef __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_WinImportHandler_ah__
#define __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_WinImportHandler_ah__
#include "WinImportHandler.ah"
#endif
#endif
#ifdef __ac_need__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_WinMacros_ah__
#ifndef __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_WinMacros_ah__
#define __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_WinMacros_ah__
#include "WinMacros.ah"
#endif
#ifndef __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_PragmaOnceUnitState_ah__
#define __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_PragmaOnceUnitState_ah__
#include "PragmaOnceUnitState.ah"
#endif
#endif
#ifdef __ac_need__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_WinAsm_ah__
#ifndef __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_WinAsm_ah__
#define __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_WinAsm_ah__
#include "WinAsm.ah"
#endif
#ifndef __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_ExtACTree_ah__
#define __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_ExtACTree_ah__
#include "ExtACTree.ah"
#endif
#endif
#ifdef __ac_need__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_WinDeclSpecs_ah__
#ifndef __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_WinDeclSpecs_ah__
#define __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_WinDeclSpecs_ah__
#include "WinDeclSpecs.ah"
#endif
#endif
#ifdef __ac_need__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_WinMemberExplSpec_ah__
#ifndef __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_WinMemberExplSpec_ah__
#define __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_WinMemberExplSpec_ah__
#include "WinMemberExplSpec.ah"
#endif
#endif
#ifdef __ac_need__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_WinTypeKeywords_ah__
#ifndef __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_WinTypeKeywords_ah__
#define __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_WinTypeKeywords_ah__
#include "WinTypeKeywords.ah"
#endif
#endif
#ifdef __ac_need__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_WinFriend_ah__
#ifndef __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_WinFriend_ah__
#define __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_WinFriend_ah__
#include "WinFriend.ah"
#endif
#endif
#ifdef __ac_need__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_ExtAC_ah__
#ifndef __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_ExtAC_ah__
#define __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_ExtAC_ah__
#include "ExtAC.ah"
#endif
#ifndef __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_ExtACTree_ah__
#define __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_ExtACTree_ah__
#include "ExtACTree.ah"
#endif
#ifndef __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_ExtACKeywords_ah__
#define __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_ExtACKeywords_ah__
#include "ExtACKeywords.ah"
#endif
#ifndef __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_ExtGnu_ah__
#define __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_ExtGnu_ah__
#include "ExtGnu.ah"
#endif
#ifndef __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_PragmaOnceUnitState_ah__
#define __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_PragmaOnceUnitState_ah__
#include "PragmaOnceUnitState.ah"
#endif
#ifndef __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_CMatchSyntax_ah__
#define __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_CMatchSyntax_ah__
#include "CMatchSyntax.ah"
#endif
#endif
#ifdef __ac_need__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_ExtACBuilderH_ah__
#ifndef __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_ExtACBuilderH_ah__
#define __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_ExtACBuilderH_ah__
#include "ExtACBuilderH.ah"
#endif
#endif
#ifdef __ac_need__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_ExtACBuilderCC_ah__
#ifndef __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_ExtACBuilderCC_ah__
#define __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_ExtACBuilderCC_ah__
#include "ExtACBuilderCC.ah"
#endif
#ifndef __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_ExtACTree_ah__
#define __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_ExtACTree_ah__
#include "ExtACTree.ah"
#endif
#endif
#ifdef __ac_need__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_ExtACSyntaxH_ah__
#ifndef __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_ExtACSyntaxH_ah__
#define __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_ExtACSyntaxH_ah__
#include "ExtACSyntaxH.ah"
#endif
#endif
#ifdef __ac_need__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_ExtACSyntaxCC_ah__
#ifndef __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_ExtACSyntaxCC_ah__
#define __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_ExtACSyntaxCC_ah__
#include "ExtACSyntaxCC.ah"
#endif
#endif
#ifdef __ac_need__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_ExtACTree_ah__
#ifndef __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_ExtACTree_ah__
#define __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_ExtACTree_ah__
#include "ExtACTree.ah"
#endif
#endif
#ifdef __ac_need__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_ExtACKeywords_ah__
#ifndef __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_ExtACTree_ah__
#define __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_ExtACTree_ah__
#include "ExtACTree.ah"
#endif
#ifndef __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_ExtACKeywords_ah__
#define __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_ExtACKeywords_ah__
#include "ExtACKeywords.ah"
#endif
#ifndef __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_ExtGnu_ah__
#define __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_ExtGnu_ah__
#include "ExtGnu.ah"
#endif
#ifndef __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_PragmaOnceUnitState_ah__
#define __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_PragmaOnceUnitState_ah__
#include "PragmaOnceUnitState.ah"
#endif
#endif
#ifdef __ac_need__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_ExtGnu_ah__
#ifndef __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_ExtACTree_ah__
#define __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_ExtACTree_ah__
#include "ExtACTree.ah"
#endif
#ifndef __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_ExtGnu_ah__
#define __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_ExtGnu_ah__
#include "ExtGnu.ah"
#endif
#ifndef __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_PragmaOnceUnitState_ah__
#define __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_PragmaOnceUnitState_ah__
#include "PragmaOnceUnitState.ah"
#endif
#endif
#ifdef __ac_need__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_ExtGnuCSemDeclSpecs_ah__
#ifndef __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_ExtACTree_ah__
#define __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_ExtACTree_ah__
#include "ExtACTree.ah"
#endif
#ifndef __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_ExtGnuCSemDeclSpecs_ah__
#define __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_ExtGnuCSemDeclSpecs_ah__
#include "ExtGnuCSemDeclSpecs.ah"
#endif
#endif
#ifdef __ac_need__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_PragmaOnceUnitState_ah__
#ifndef __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_PragmaOnceUnitState_ah__
#define __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_PragmaOnceUnitState_ah__
#include "PragmaOnceUnitState.ah"
#endif
#endif
#ifdef __ac_need__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_PragmaOnce_ah__
#ifndef __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_PragmaOnceUnitState_ah__
#define __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_PragmaOnceUnitState_ah__
#include "PragmaOnceUnitState.ah"
#endif
#ifndef __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_PragmaOnce_ah__
#define __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_PragmaOnce_ah__
#include "PragmaOnce.ah"
#endif
#endif
#ifdef __ac_need__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_TraceSyntax_ah__
#ifndef __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_TraceSyntax_ah__
#define __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_TraceSyntax_ah__
#include "TraceSyntax.ah"
#endif
#endif
#ifdef __ac_need__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_CMatchSyntax_ah__
#ifndef __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_CMatchSyntax_ah__
#define __ac_have__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_aspects_CMatchSyntax_ah__
#include "CMatchSyntax.ah"
#endif
#endif
#undef __ac_FIRST__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1__
#undef __ac_FIRST_FILE__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_inc_Puma_BCList_h__
#endif // __ac_FIRST_FILE__tmp_tmp_jwSEixqBhI_aspectc4343_svn20090918_Puma_gen45release_step1_inc_Puma_BCList_h__
